unit uchart;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, ExtCtrls, StdCtrls, AdvChart, AdvChartView,
  AdvChartViewGDIP;

type
  TForm2 = class(TForm)
    chart: TAdvGDIPChartView;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure DrawMarker(Sender: TObject; Serie: TChartSerie; Canvas: TCanvas;
      X, Y, Point: integer; value: TChartPoint);

    procedure XAxisDrawValue(Sender: TObject; Serie: TChartSerie;
      Canvas: TCanvas; ARect: TRect; ValueIndex, XMarker: integer; Top: Boolean;
      var defaultdraw: Boolean);

    procedure YAxisDrawValue(Sender: TObject; Serie: TChartSerie; Canvas: TCanvas; ARect: TRect;
       Value: double; Left: Boolean; var defaultdraw: Boolean);
  end;

var
  Form2: TForm2;

implementation

var   colorChart : TColor;
      colorMarker : TColor;

{$R *.dfm}

procedure TForm2.Button1Click(Sender: TObject);
var
  I: integer;
begin
   colorChart := clGrayText;
   colorMarker := clNavy;

  Chart.BeginUpdate;
  Chart.Panes.Clear;

  Chart.Panes.Add;

  //Chart.Panes[0].Options := Chart.Panes[0].Options;
  // + [poMoving, poHorzScroll,poHorzScale];

// Serie

  Chart.Panes[0].Series.Add;
  Chart.Panes[0].Legend.Visible := false;
  Chart.Panes[0].Series[0].ShowValue := false;
  Chart.Panes[0].Series[0].xaxis.XYValues := false;
  Chart.Panes[0].Series[0].OnMarkerDrawValue := DrawMarker;
  Chart.Panes[0].Series[0].OnXAxisDrawValue := XAxisDrawValue;
  //Chart.Panes[0].Series[0].OnYAxisDrawValue := YAxisDrawValue;

  Chart.Panes[0].Series[0].Xaxis.MajorFont.Name := 'Avenir LT Pro 55 Roman';
  Chart.Panes[0].Series[0].Xaxis.MajorFont.Size := 10;
  Chart.Panes[0].Series[0].Yaxis.MajorFont.Name := 'Avenir LT Pro 55 Roman';
  Chart.Panes[0].Series[0].Yaxis.MajorFont.Size := 10;

  Chart.Panes[0].Series[0].BorderWidth:=0;

  with Chart.Panes[0] do begin
    Margin.LeftMargin:=00;
    Margin.TopMargin:=0;
    Margin.RightMargin:=10;
    Margin.BottomMargin:=00;


    Title.Alignment := taCenter;
    Title.Font.Charset := DEFAULT_CHARSET;
    Title.Font.Color := colorChart;
    Title.Font.Size := 16;
    Title.Font.Name := 'Avenir LT Pro 55 Roman';
    Title.Font.Style := [];
    Title.Position := tTop;
    Title.Size := 40;
    Title.Text := 'Kaufpreise in /m fr die Jahre 2018 - 2023';

//?    AxisMode:=amxAxisFullWidth;

    XAxis.LineWidth:=2;
    XAxis.LineColor:=colorChart;

    YAxis.LineWidth:=2;
    YAxis.LineColor:=colorChart;
    YAxis.AutoSize:=false;
    yAxis.AutoUnits:=false;
    yAxis.Size:=100;

    yGrid.AutoUnits:=false;
    YGrid.MinorDistance := 0;
    YGrid.MajorDistance := 2500;
    YGrid.MinorLineColor := clSilver;
    YGrid.MinorLineStyle := psSolid;
    YGrid.MajorLineWidth := 1;
    YGrid.Visible := True;
  end;

  with Chart.Panes[0].Series[0] do
  begin
    ChartType := ctXYMarkers;
    ShowValue := False;
    ValueFormat := '%.0n';
    ValueWidth := 0;

    Marker.MarkerType := mCustom;
    Marker.MarkerSize := 0;
    Marker.MarkerColor := clWhite;

    XAxis.DateTimeFont.Charset := DEFAULT_CHARSET;
    XAxis.DateTimeFont.Color := clWindowText;
    XAxis.DateTimeFont.Height := -11;
    XAxis.DateTimeFont.Name := 'Avenir LT Pro 55 Roman';
    XAxis.DateTimeFont.Style := [];
    XAxis.MajorFont.Charset := ANSI_CHARSET;
    XAxis.MajorFont.Color := clWindowText;
    XAxis.MajorFont.Size := 16;
    XAxis.MajorFont.Name := 'Avenir LT Pro 55 Roman';
    XAxis.MajorFont.Style := [];
    XAxis.MajorUnit := 1.000000000000000000;
    XAxis.MajorUnitSpacing := 10;
    XAxis.MinorFont.Charset := ANSI_CHARSET;
    XAxis.MinorFont.Color := clWindowText;
    XAxis.MinorFont.Size := 16;
    XAxis.MinorFont.Name := 'Avenir LT Pro 55 Roman';
    XAxis.MinorFont.Style := [];
    XAxis.MinorUnit := 1.000000000000000000;
    XAxis.MinorUnitSpacing := 0;
    XAxis.TextTop.Font.Charset := DEFAULT_CHARSET;
    XAxis.TextTop.Font.Color := clWindowText;
    XAxis.TextTop.Font.Height := -11;
    XAxis.TextTop.Font.Name := 'Avenir LT Pro 55 Roman';
    XAxis.TextTop.Font.Style := [];
    xAxis.TextTop.Angle := 0;
    XAxis.TextBottom.Font.Charset := DEFAULT_CHARSET;
    XAxis.TextBottom.Font.Color := clWindowText;
    XAxis.TextBottom.Font.Size := 16;
    XAxis.TextBottom.Font.Name := 'Avenir LT Pro 55 Roman';
    XAxis.TextBottom.Font.Style := [];
    xAxis.TextBottom.Angle := 0;
    XAxis.TickMarkSize := 0;

  //  YAxis.AutoUnits := true; // false;
    YAxis.MajorFont.Charset := ANSI_CHARSET;
    YAxis.MajorFont.Color := colorChart;
    YAxis.MajorFont.Size := 14;
    YAxis.MajorFont.Name := 'Avenir LT Pro 55 Roman';
    YAxis.MajorFont.Style := [];
    YAxis.MajorUnit := 2500;
    YAxis.MajorUnitSpacing := 10;
    YAxis.MajorUnitVisible:=true;
    YAxis.MinorFont.Charset := ANSI_CHARSET;
    YAxis.MinorFont.Color := clWindowText;
    YAxis.MinorFont.Size := 12;
    YAxis.MinorFont.Name := 'Avenir LT Pro 55 Roman';
    YAxis.MinorFont.Style := [];
    YAxis.MinorUnit := 0;
    YAxis.MinorUnitVisible := false;
    YAxis.MinorUnitSpacing := 0;
    YAxis.TextLeft.Angle := -90;
    YAxis.TextLeft.Font.Charset := ANSI_CHARSET;
    YAxis.TextLeft.Font.Color := clWindowText;
    YAxis.TextLeft.Font.Size := 20;
    YAxis.TextLeft.Font.Name := 'Avenir LT Pro 55 Roman';
    YAxis.TextLeft.Font.Style := [fsBold];
    YAxis.TextLeft.Font.Color := colorChart;
    YAxis.TextLeft.Position := ctCenter;
    YAxis.TextLeft.Text := ''; // 'Kaufpreis '#8364'/m2';
    YAxis.TextRight.Angle := 0;
    YAxis.TextRight.Font.Charset := DEFAULT_CHARSET;
    YAxis.TextRight.Font.Color := clWindowText;
    YAxis.TextRight.Font.Height := -11;
    YAxis.TextRight.Font.Name := 'Avenir LT Pro 55 Roman';
    YAxis.TextRight.Font.Style := [];
    YAxis.TickMarkColor := colorChart;
    YAxis.TickMarkSizeMinor := 0;
    YAxis.TickMarkSize:=0;
    YAxis.TickMarkWidth := 2;

    ZeroLineWidth := 0;



    AddSingleXYPoint(0, 20000);
    AddSingleXYPoint(0, 19000);
    AddSingleXYPoint(2, 5000);
    AddSingleXYPoint(3, 7500);
    AddSingleXYPoint(3, 2500);

    //AddSingleXYPoint(1, 30);
    //AddSingleXYPoint(3, 40);

    for i := 1 to 60 do
    begin
      AddSingleXYPoint(0, 400 + Random(20000));
      AddSingleXYPoint(1, 400 + Random(20000));
      AddSingleXYPoint(2, 400 + Random(20000));
      AddSingleXYPoint(3, 400 + Random(40));
      AddSingleXYPoint(4, 400 + Random(20000));
      AddSingleXYPoint(5, 400 + Random(14000));
    end;

    
    AddSingleXYPoint(5, 9000,'bla');

    //   AddSinglePoint(50 * sin(i / 20 * PI));

    AutoRange :=  arDisabled; // EnabledZeroBased; //arCommon;
    Maximum := 22500;
    Minimum := 0;
    yAxis.MajorUnit:=2500;
    yAxis.MinorUnit:=0;
  end;
//  Chart.Panes[0].Series[0].AutoRange := arEnabledZeroBased; //arCommon;

  Chart.Panes[0].Range.RangeFrom := 0;
  Chart.Panes[0].Range.RangeTo := 5;

  //Chart.Panes[0].Series[0].Autorange := arEnabled;
  Chart.EndUpdate;
end;

procedure TForm2.Button2Click(Sender: TObject);
var
wmf : TMetaFile;
wmfcanvas : tmetafilecanvas;
r : trect;
begin
   wmf:=Chart.createmetafile(chart.Width,chart.height);
   wmf.savetofile('c:\temp\testwmf.emf');
   wmf.free;
   exit;

   // Metafile

   Wmf := TMetafile.Create;
   Wmf.Enhanced := True;
   WmfCanvas := TMetafileCanvas.CreateWithComment( Wmf, 0, 'Marco', 'Demo metafile');

   r.Left:=0;r.top:=0;r.right:=2000;r.bottom:=2000;
   Chart.PrintPane(0,WmfCanvas,R);


   wmf.SaveToFile('c:\temp\test.emf');
   wmfcanvas.Free;
   wmf.Free;
end;

procedure TForm2.DrawMarker(Sender: TObject; Serie: TChartSerie; Canvas:
  TCanvas; X, Y, Point: integer; value: TChartPoint);
begin
  if value.LegendValue<>'' then begin // Objekt
     Canvas.Pen.Color := $00281DB5;
     Canvas.Brush.Color:= $00281DB5;
    // canvas.Ellipse(x-5,y-5,x+5,y+5);
     //canvas.Rectangle(x+20,y-5,x+31,y+5);
     Canvas.MoveTo(x-30,y);
     Canvas.Pen.Width := 4;
     Canvas.lineto(x + 30, y);

  end else begin
    Canvas.Pen.Color := colorMarker;
    Canvas.Pen.Width := 2;
    canvas.MoveTo(X - 10, y);
    Canvas.lineto(x + 10, y);
  end;
end;

procedure TForm2.XAxisDrawValue(Sender: TObject; Serie: TChartSerie;
  Canvas: TCanvas; ARect: TRect; ValueIndex, XMarker: integer; Top: Boolean;
  var defaultdraw: Boolean);

var
  s: string;
  th, tw: integer;
begin
  Defaultdraw := false;
  Canvas.Font.Size := 14;
  Canvas.Font.Name:= 'Avenir LT Pro 55 Roman';
  Canvas.Font.Orientation:=0;
  Canvas.Font.Style:=[];
  Canvas.Font.Color:=colorChart;


  s := IntToStr(2018 + ValueIndex);
  th := Canvas.TextHeight(s);
  tw := Canvas.TextWidth(s);
  Canvas.TextOut(Xmarker - (tw div 2), ARect.Top + th, s);
end;

procedure TForm2.YAxisDrawValue(Sender: TObject; Serie: TChartSerie; Canvas: TCanvas; ARect: TRect;
    Value: double; Left: Boolean; var defaultdraw: Boolean);
var
  s: string;
  th, tw: integer;
begin
  exit;
  {Defaultdraw := false;
  Canvas.Font.Size := 12;
  Canvas.Font.Style:=[];

  Canvas.Font.Color:=colorChart;
  s := FloatToStr(Value)+' ';//showmessage(S);
  th := Canvas.TextHeight(s);
  tw := Canvas.TextWidth(s);
  Canvas.TextOut(ARect.Right-tw-10, ARect.Top + th, s);     }
end;


end.
